//////////////////////////////////////////////////////////////////////////////////
// Stuff (c) 2007 G-Truc Creation (www.g-truc.net)
//////////////////////////////////////////////////////////////////////////////////
// File    : singleton.inl
// Author  : Christophe [Groove] Riccio (g.truc.creation [at] gmail [point] com)
// Created : 2007-08-02
// Updated : 2007-08-02
// Licence : This source is under GNU LGPL licence
//////////////////////////////////////////////////////////////////////////////////

namespace stuff
{
	template<typename T>
	T* singleton<T>::instance;

	template<typename T>
	singleton<T>::~singleton()
	{
		release();
	}

	template<typename T>
	T& singleton<T>::get()
	{
		if(empty())
			instance = new T;
		return *instance;
	}

	template<typename T> 
	void singleton<T>::release()
	{
		delete instance;
	}

	template<typename T> 
	bool singleton<T>::empty()
	{
		return instance == 0;
	}
}
